#include <fstream.h>
#include <math.h>



char datei_ergebnis[]={"primzahlen.dat"};
char datei_config[]={"config.dat"};

bool prim(unsigned long *array, unsigned long pruefzahl, unsigned long stand);
void file_exist();


void main()
{
	//Variablenvereinbarungen
	unsigned long size;
	unsigned long stand;
	unsigned long pruefzahl;
	//unsigned long garbage;
	unsigned long ziel;
	unsigned long maximum=0;
	 maximum--;
	char l1=0xC9;
	char l2=0xCD;
	char l3=0xBB;
	char l4=0xC8;
	char l5=0xBC;
	char l6=0xBA;
	char titel[]={" BRT006-Primzahlengenerator V1.5 "};
	bool ergebnis;
	unsigned long progressbar, progress_schritt, anfangsstand;
	long sekunden;
	long minuten=0;
	time_t t1;
 	time_t t2; 
	time_t t3;
	time_t t4;
	
	
	//Titel ausgeben
	cout << endl << endl << endl;
	cout << l1;
	for(int i=0;i<sizeof(titel);i++)
		cout << l2;
	cout << l3 << endl;
	cout << l6 << titel <<" "<< l6 << endl;
	cout << l4;
	for(int i=0;i<sizeof(titel);i++)
		cout << l2;
	cout << l5 << endl;
	
	//Funktionsaufruf
	file_exist();
	
	 	
	//Configdaten importieren
	ifstream inConfig;
	inConfig.open(datei_config);
	inConfig>>stand;
	inConfig>>size;
	inConfig.close();
	
	//Hilfsvariablen fr Progressbar whrend des Imports der Daten
	anfangsstand=stand;
	progressbar=stand/21;
	progress_schritt=progressbar;
	
	 
	//Feld fr die Primzahlen erzeugen	
	unsigned long *primfeld;
	primfeld=new unsigned long [size];
	


	//Timerzeit nehmen
	t1 = time(NULL);
	
	//Bisher vorliegende Primzahlen importieren
	ifstream inErg;
	inErg.open(datei_ergebnis);
	
	cout << "Importiere Primzahlen:";	
	for(unsigned long i=0;i<stand;i++)
	{
		//inErg>>garbage;
		inErg>>primfeld[i];
		if(i==progressbar)
		{
			cout << ".";
			progressbar+=progress_schritt;
		}
	}
	cout << endl;
	inErg.close(); 
	
	//Timerzeit nehmen
	t2 = time(NULL);
	
	//Benutzereingabe ber Rechenziel
	cout << endl << "Wie weit soll gerechnet werden?" << endl;
	cout <<         "(Stand: " << stand << ")"<<endl;
	cin>>ziel;
	cout << endl << "Ergebnisse werden nicht dargestellt, sondern"<<endl;
	cout << "in Datei: primzahlen.dat ausgegeben." << endl<<endl;
	cout << "Rechne" << endl;
	
	//Ergebnisdatei zum Export ffnen
	ofstream outErg(datei_ergebnis,ios::app);
	
	//Timerzeit nehmen
	t3 = time(NULL);
	

	//Prfprozess
	pruefzahl=primfeld[stand-1]+1;
	while(stand-1<size&&ziel>stand&&pruefzahl-1<maximum)
	{
		
		ergebnis=prim(primfeld,pruefzahl,stand);
		if(ergebnis)
		{
			
			primfeld[stand]=pruefzahl;
			stand++;
			outErg<<pruefzahl<<endl;
			
		}


		pruefzahl++;
		//laufzaehler++;
		
				
	}
	
	//Timerzeit nehmen
	t4 = time(NULL);
	
	//Ergebnisdatei schlieen
	outErg.close(); 
	
	//ffnen der Konfigurationsdatei und Rckschreiben des Ergebnisstandes
	ofstream outStand(datei_config,ios::trunc);
 	outStand << stand << endl << size;
 	outStand.close(); 
	


	//Anzeige der Laufzeit
	cout << endl << "*********************************************" << endl << endl;
	
	cout << "Import von " << anfangsstand << " Primzahlen dauerte " << t2-t1 << " Sekunden. "<< endl;
	cout << stand-anfangsstand << " Primzahlen wurden erzeugt." << endl;
	cout << "Von " << anfangsstand << " bis " << stand << endl;
	sekunden = t4-t3;
 	
 	if(sekunden>0)
 	{
 		while(sekunden>=60)
  		{
   			sekunden -=60;
   			minuten++;
  		}
  	}
 	
 	if(minuten>0)
 	{
 		cout << "Dauer: " << minuten << " Minuten und " << sekunden << " Sekunden.";
 	}
 	else
 	{
 		cout << "Dauer: " << sekunden << " Sekunden.";	
  		cout << endl << endl << "*********************************************";
  	}
	
	
	//Heap-Speicher freigeben
	delete[] primfeld;	
	
}



//Funktion zur Prfung auf Primeigenschaft
bool prim(unsigned long *array, unsigned long pruefzahl, unsigned long stand)
{
	bool prim;
	unsigned long lim;
	lim=sqrt(pruefzahl)+1;
	for(unsigned long i=0;i<stand;i++)
	{
		
		
		if(pruefzahl%array[i]==0)
		{
			prim=0;
			break;
		}else
		if(lim<array[i])
		{
			prim=1;
			break;
		}
		prim=1;
	}
 return prim;
}





void file_exist()//Prft ob Ausgabedatei existiert und erzeugt ggf. neue
{
	
	ifstream test(datei_ergebnis);
	if(!test)
	{
		unsigned long zaehlerstand=4;
		unsigned long feldgroesse=4000000;
		cout << endl << endl;
		cout << "Erzeuge Ausgabe- und Config-Datei" << endl;
		ofstream out1(datei_ergebnis);
		out1<<"2"<<endl;
		out1<<"3"<<endl;
		out1<<"5"<<endl;
		out1<<"7"<<endl;
		out1.close();
		ofstream out2(datei_config);
		out2<<zaehlerstand<<endl<<feldgroesse;
		out2.close();		
	}
}

